if(isfile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Toggle","Saved Checkpoints","CS::Toggle","bool","Script_SavedCheckpoints",1,0,1);
	RTB_registerPref("Can Reset All Checkpoints","Saved Checkpoints","CS::CanReset","list Host 1 SuperAdmin 2 Admin 3","Script_SavedCheckpoints",2,0,1);
}
else
{
	$CS::Toggle = 1;
	$CS::CanReset = 2;
}

package CheckpointSaving
{	
	function brickCheckpointData::onPlayerTouch(%data, %obj, %player)
	{
		Parent::onPlayerTouch(%data, %obj, %player);
		if($CS::Toggle)
		{
			%client = %player.client;
			SaveCheckPoint(%client,%obj);
		}
	}

	function SaveCheckPoint(%client,%obj)
	{
		%file = new FileObject();
		%file.openForWrite("Config/Server/SavedCheckPoints/"@%client.bl_id@".txt");
		%file.writeline(%obj.getposition());
		%file.close();
		%file.delete();
	}

	function LoadCheckPoint(%client)
	{
		if(!isfile("Config/Server/SavedCheckPoints/"@%client.bl_id@".txt"))
			return;
		%file = new FileObject();
		%file.openForRead("Config/Server/SavedCheckPoints/"@%client.bl_id@".txt");
		%pos = %file.readline();
		%client.player.settransform(%pos);
		%file.close();
		%file.delete();
	}

	function serverCmdclearcheckpoint(%client)
	{
		if($CS::Toggle)
		{
			if(isfile("Config/Server/SavedCheckPoints/"@%client.bl_id@".txt"))
				filedelete("Config/Server/SavedCheckPoints/"@%client.bl_id@".txt");
		}
		Parent::serverCmdclearcheckpoint(%client);
	}
	
	function serverCmdresetsavedcheckpoints(%client)
	{
		%host = %client.bl_id == getnumkeyid();
		switch($CS::CanReset)
		{
			case 1:
				if(!%host)
				{
					MessageClient(%client,'',"\c6You are not allowed to reset checkpoints");
					return;
				}
			case 2:
				if(!%client.isSuperAdmin)
				{
					MessageClient(%client,'',"\c6You are not allowed to reset checkpoints");
					return;
				}
			case 3:
				if(!%client.isAdmin)
				{
					MessageClient(%client,'',"\c6You are not allowed to reset checkpoints");
					return;
				}
		}
		for(%i = findFirstFile("Config/Server/SavedCheckpoints/*.cs");%i!$="";%i=findNextFile("Config/Server/SavedCheckpoints/*.cs"))
			filedelete(%i);
		MessageAll('',"\c6Saved checkpoints have been reset");
	}

	function GameConnection::spawnPlayer(%client)
	{
		Parent::spawnPlayer(%client);
		if($CS::Toggle)
			LoadCheckPoint(%client);
	}
};
activatepackage(CheckpointSaving);
		
		